<template>
  <div>
    <rui-list-item v-if="element.implantedAt"
                   :caption="$t('activerecord.attributes.element.implanted_at')"
                   :sub-caption="$d(element.implantedAt, 'date')"
                   inline
                   static>
      <template #subCaption>
        <div class="-inline-flex -gap">
          <span>{{ $d(element.implantedAt, 'date') }}</span>
          <rui-tag v-if="element.implantationMode"
                   :tag="$t(`activerecord.attributes.element/implantation_mode.${element.implantationMode}`)" />
        </div>
      </template>
    </rui-list-item>
    <template v-else>
      <rui-icon-text v-if="!element.implantationPlannedFor"
                     variant="warning"
                     :text="$t('js.elements.item_content.no_implantation_planned')"
                     icon="warning" />

      <rui-list-item v-else
                     :caption="$t('js.elements.item_content.implantation_planned_for')"
                     static>
        <template #subCaption>
          <div class="-inline-flex -gap">
            <span :class="actionCSS(element.implantationPlannedFor)">{{ $d(element.implantationPlannedFor, 'date') }}</span>
            <rui-tag v-if="element.implantationMode"
                     :tag="$t(`activerecord.attributes.element/implantation_mode.${element.implantationMode}`)" />
          </div>
        </template>
        <template #right>
          <rui-button icon="check" :title="$t('js.elements.item_content.implant_now')" variant="recording" @click="implantNow" />
          <rui-button icon="pencil" :title="$t('generic.edit')" @click="$emitBus('show-implantation-form', element)" />
          <rui-button icon="cancel" :title="$t('generic.cancel')" variant="destructive" @click="cancelImplantationPlanning" />
        </template>
      </rui-list-item>
    </template>

    <rui-list-item v-if="element.removedAt"
                   :caption="$t('activerecord.attributes.element.removed_at')"
                   :sub-caption="$d(element.removedAt, 'date')"
                   inline
                   static />
    <rui-list-item v-else-if="element.removalPlannedFor"
                   :caption="$t('js.elements.item_content.removal_planned_for')"
                   class="-p0"
                   static>
      <template #subCaption>
        <span :class="actionCSS(element.removalPlannedFor)">{{ $d(element.removalPlannedFor, 'date') }}</span>
      </template>
      <template #right>
        <rui-button icon="check" :title="$t('js.elements.item_content.remove_now')" variant="recording" @click="removeNow" />
        <rui-button icon="pencil" :title="$t('generic.edit')" @click="$emitBus('show-removal-form', element)" />
        <rui-button icon="cancel" :title="$t('generic.cancel')" variant="destructive" @click="cancelRemovalPlanning" />
      </template>
    </rui-list-item>
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiTag from '@experiments-labs/rise_ui/src/components/DataDisplay/Tag/Tag.vue'
import RuiIconText from '@experiments-labs/rise_ui/src/components/IconText/IconText.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'

import Element from '../../../../classes/models/Element'
import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import Toaster from '../../../../tools/Toaster'
import { isSameDay, isOver } from '@experiments-labs/rise_ui/src/lib/Dates'

export default {
  name: 'GpaElementDetails',
  components: { RuiButton, RuiIconText, RuiTag, RuiListItem },
  props: {
    element: { required: true, type: Element },
  },
  data () {
    return {
      loading: false,
      formId: randomString(),
      now: new Date(),
    }
  },
  methods: {
    cancelRemovalPlanning () {
      this.save('updateElement', { id: this.$props.element.id, removal_planned_for: null })
    },
    cancelImplantationPlanning () {
      this.save('updateElement', { id: this.$props.element.id, implantation_planned_for: null })
    },
    save (action, payload) {
      this.errors = null
      this.loading = true
      return this.$store.dispatch(action, payload)
        .catch((error) => {
          this.errors = error
        })
        .then(() => { this.loading = false })
    },

    implantNow () {
      this.loading = true
      this.$store.dispatch('implantElement', { id: this.$props.element.id, date: new Date().toISOString() })
        .then(() => { Toaster.success(this.$t('js.elements.item_content.successfully_implanted')) })
        .catch(() => { Toaster.error(this.$t('js.elements.item_content.failed_to_implant')) })
        .then(() => { this.loading = false })
    },
    removeNow () {
      this.loading = true
      this.$store.dispatch('removeElement', { id: this.$props.element.id, date: new Date().toISOString() })
        .then(() => { Toaster.success(this.$t('js.elements.item_content.successfully_removed')) })
        .catch(() => { Toaster.error(this.$t('js.elements.item_content.failed_to_remove')) })
        .then(() => { this.loading = false })
    },
    actionCSS (date) {
      return {
        'text--color-warning': isSameDay(date, this.now),
        'text--color-danger': isOver(date, this.now),
      }
    },
  },
}
</script>
